
///////////////////////////////////////////////////////////////////////////
// DOCB Code
// Version 1.0, Feb. 2002
// Zhen He
// Australian National University
// DROStatc.h: DRO statistics (classes)
///////////////////////////////////////////////////////////////////////////
class DROObjStats {

 private:

  int _objId;
  int _accessFreq;
  bool _usageIndicator;

 public:
  
  DROObjStats(int objId);
  void setUsageIndicator(bool ui);
  bool getUsageIndicator();
  void resetUsageIndicator();
  void incAccessFreq();
  int getAccessFreq();
  int getOid();
  void resetStats();

};


class DROPageStats {

 private:

  int _pageId;
  int _nbLoad;
  hash_map< int, DROObjStats *, hash<int>, eqoid > _objStats;

 public:

  DROPageStats(int pageId);
  ~DROPageStats();
  void incNbLoad();
  int getNbLoad();
  void resetNbLoad();
  int getPid();

  DROObjStats * getObjStats(int objId);
  bool deleteObjStats(int objId);
  
  bool insertObject(int objId);
  bool objExists(int objId);

  bool setObjUsageIndicator(int objId, bool ui);
  bool getObjUsageIndicator(int objId);
  bool incObjAccessFreq(int objId);
  int getObjAccessFreq(int objId);
  float computeUsageRate();
  void resetAllObjUsageIndicator();
  vector<int> getUsedObjects();
  vector<int> getUnusedObjects();
  vector<int> getAllObjects();
  vector<DROObjStats *> removeAllObjStats();
  void insertObjStats(DROObjStats * stats);
  void resetStats();
};


