
///////////////////////////////////////////////////////////////////////////
// DOCB Code
// Version 1.0, Feb. 2002
// Zhen He
// Australian National University
// pqueuec.h: Custom made priority queue (classes)
///////////////////////////////////////////////////////////////////////////

#include <multimap.h>
#include <set.h>
#include <hash_map.h>

struct float_comp {
  bool operator() (const float f1, const float f2) {
    return (f1 > f2);
  }
};

struct eq_int {
  bool operator() (const int d1, const int d2) {
    return (d1 == d2);
  }
};

class PQueue {
 public:

  PQueue();

  void InsertElem(float key, int page_num);
  
  int PopTopElem();
  
  int PopBottomElem();

  bool PageExists(int page_num);

  bool RemovePage(int page_num);
  void ClearQueue();

  int Size();
  
  int StartIter();
  
  int Next();  

  int End();
  
  void RemoveAtIter();

 private:
  multimap<const float, int, float_comp> _queue;
  // reverse queue which allows queue to be updated with page num as index
  hash_map<const int, float, hash<int>, eq_int> _r_queue;
  multimap<const float, int, float_comp>::iterator _internal_iter;
  int EndInt;
};



