
/////////////////////////////////////////////////////////////////////
// VOODB2 (Virtual Object Oriented Database)
// Modele d'evaluation de performances generique pour SGBDOO
// Version 2.0 C++, avril 1998
// Jerome Darmont
// LIMOS, Universite Blaise Pascal (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// Updated
// -------
// Name: Zhen He
// Institution: Australian National University
// Date: Feb. 2002
/////////////////////////////////////////////////////////////////////
// voodb2.h :   - Definition des variables globales
//              - Definition de fonctions utilitaires
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Constantes
/////////////////////////////////////////////////////////////////////



//#define CHANGE_SEED /*** needed by DOCB paper ***/

//#define CONCURRENCY_ON

//#define DEBUG

// Valeurs critiques pour la t-distribution de Student 
// pour gamma=0,975 (Calcul d'intervalles de confiance  95%)
// Indice   0 : n=1
// ...
// Indice  99 : n=100
// Indice 100 : n=102
// ...
// Indice 124 : n=150
// Indice 125 : n=200
// ...
// Indice 133 : n=1000
// Indice 134 : n=infini
/*
const float TDIST[135]={
  // 1..100	
 12.7062, 4.3027, 3.1824, 2.7764, 2.5706,
  2.4469, 2.3646, 2.3060, 2.2622, 2.2281,
  2.2010, 2.1788, 2.1604, 2.1448, 2.1315,
  2.1199, 2.1098, 2.1009, 2.0930, 2.0860,
  2.0796, 2.0739, 2.0687, 2.0639, 2.0595,
  2.0555, 2.0518, 2.0484, 2.0452, 2.0423,
  2.0395, 2.0369, 2.0345, 2.0322, 2.0301,
  2.0281, 2.0262, 2.0244, 2.0227, 2.0211,
  2.0195, 2.0181, 2.0167, 2.0154, 2.0141,
  2.0129, 2.0117, 2.0106, 2.0096, 2.0086,
  2.0076, 2.0066, 2.0057, 2.0049, 2.0040,
  2.0032, 2.0025, 2.0017, 2.0010, 2.0003,
  1.9996, 1.9990, 1.9983, 1.9977, 1.9971,
  1.9966, 1.9960, 1.9955, 1.9949, 1.9944,
  1.9939, 1.9935, 1.9930, 1.9925, 1.9921,
  1.9917, 1.9913, 1.9908, 1.9905, 1.9901,
  1.9897, 1.9893, 1.9890, 1.9886, 1.9883,
  1.9879, 1.9876, 1.9873, 1.9870, 1.9867,
  1.9864, 1.9861, 1.9758, 1.9855, 1.9853,
  1.9850, 1.9847, 1.9845, 1.9842, 1.9840,
  // 102..150
  1.9835, 1.9830, 1.9826, 1.9822, 1.9818,
  1.9814, 1.9810, 1.9806, 1.9803, 1.9799,
  1.9796, 1.9793, 1.9790, 1.9787, 1.9784, 
  1.9781, 1.9778, 1.9776, 1.9773, 1.9771,
  1.9768, 1.9766, 1.9763, 1.9761, 1.9759,
  // 200-1000 + infini
  1.9719, 1.9679, 1.9659, 1.9647, 1.9639,
  1.9634, 1.9629, 1.9626, 1.9623, 1.9600
};*/



#define MOVING_HOT_REGION

#define NULL_OID -1
#define NULL_PID -1
#define NULL_PAGE_NUM -1

#define MMAXNREF  10            // Borne superieure de MAXNREF
#define MNUSERS   10            // Borne superieure de NUSERS
#define INFINITE  99            // Doit etre superieur a MNUSERS
#define MNC       50            // Borne superieure de NC
int MNO     =   100000;         // Borne superieure de NO
#define MNREFT    5             // Borne superieure de NREFT
#define MKLRU     5             // Borne superieure de KLRU
#define MBUFFSIZE 10000         // Borne superieure de BUFFSIZE

#define NTTRANS   11             // Nombre de types de transactions
#define GROUPT    (NTTRANS + 1)
#define DDWT      (NTTRANS + 2)
#define VCT       (NTTRANS + 3)



long int DEFAULT_SEED  = 127;      // Germe aleatoire par defaut

long int DB_SEED = 127;

const long int SIMSEED  = -1;

/////////////////////////////////////////////////////////////////////
// Parametres de simulation avec valeurs par defaut
/////////////////////////////////////////////////////////////////////

int OPPORTUNISTIC_READ = 1;

int OPPORTUNISTIC_WRITE = 0;

// Controle de la simulation

#define TRANSLIMIT_ON

// Default 4000000;             // Temps de simulation
float TSIM=32000000;            // Temps de simulation

int TRANSLIMIT = 10000;         // number of transactions executed 
                                // in each repetition
                                // a negative number for this value indicates
                                // percentage of working set in relation to
                                // buffer size.

//Default 10
int NREPLIC=1;                   // Nombre de replications

// Definition du systeme
// Default 3
short SYSCLASS=1;               // Classe du systeme
                                // 1 = Centralise
                                // 2 = Serveur d'Objets
                                // 3 = Serveur de Pages
                                // 4 = Serveur de BD
                                // 9 = Autre

// multi-programming level of the database
// Default 10
int MULTILVL=1;                // Niveau de multiprogrammation

// Default 1
int NUSERS=1;                   // Nombre d'utilisateurs

// Default 4096
int PGSIZE=4096;                // Taille des pages disque

// Default 500
int BUFFSIZE=1000;               // Taille du cache memoire (en nombre de pages)

// Default 0.5
float GETLOCK=0.5;              // Temps d'acquisition des verrous
                                // Time it takes to acquire a lock

// Default 0.5
float RELLOCK=0.5;              // Temps de restitution des verrous
                                // Time it takes to release a lock
// Default 18
float DISKSEA=6.5;               // Temps de recherche disque (en ms)
                                // Disk seek time
// Default 6
float DISKLAT=4.3;                // Temps de latence disque (en ms)
                                // Disk latency
// Default 1
float DISKTRA= 0.5;                // Temps de transfert disque (en ms)
                                // Disk transfer time

// Default 1024
float NETTHRU=1024;             // Debit reseau (en Ko/s)
                                // Network throughput, default 1 MB/s
//Default 0.2
float HOTRANGE = 0.015;          // The region which is hot or size of the
                                // portion of the store which is hot 
                        
//Default 0.8
float HOTACCESSPROB = 0.99;     // The probability of the hot portion of the
                               // store 

// The size the hot region moves by in each iteration, expressed as a
// fraction of the size of the hot region
float HOT_REGION_MOVE_HOT_FRACT = 0.0;

// This value is derived from HOT_REGION_MOVE_HOT_FRACT and HOTRANGE
// HOT_REGION_MOVE_SIZE = HOT_REGION_MOVE_HOT_FRACT * HOTRANGE
float HOT_REGION_MOVE_SIZE = HOT_REGION_MOVE_HOT_FRACT * HOTRANGE;

int HOT_REGION_MOVE_RATE = 0; // The number of objects accessed before the
                                 // hot region moves by a HOT_REGION_MOVE_SIZE

bool HOT_MOVE_FORWARD = true;

// Definition des composants influencant les performances

// Default 0
short CLUSTP=1;                 // Politique de groupement
                                // Algorithms 1,2 and 3 can be found on
                                // ecoop200 symposium on objects and databases
                                // 0 = Aucune
                                // 1 = Dynamic Graph Partitioning (OPCF)
                                // 2 = Dynamic PRP (OPCF)
                                // 3 = DRO 
                                // 9 = Autre (DSTC)
                                // Clustering policy,
                                // 0 = none
                                // 1 = Dyanamic Graph Partitioning (OPCF)
                                // 2 = Dynamic PRP (OPCF)
                                // 3 = DRO 
                                // 9 = other (DSTC)
 
                                

short INITP=2;                  // Placement initial des objets
                                // 1 = Sequentiel
                                // 2 = Sequentiel optimise
                                // 9 = Autre
                                // Initial object placement
                                // 1 = Sequential
                                // 2 = Optimised sequential
                                // 9 = Other

short PGREP=4;                  // Politique de remplacement des pages dans
                                // le cache
                                //
                                // 1 = RANDOM
                                // 2 = FIFO
                                // 3 = LFU
short KLRU=1;                   // 4 = LRU-K (KLRU, parametre K de LRU)
                                // 5 = CLOCK
                                // 
                                // 6 = GCLOCK
                                // 7 = LRU-K (Using History, the version on
                                //             the LRU-K [SIGMOD 93] paper.)
                                // Page replacement policy
                                // For parameters see above
                                // KLRU parameter is used to allow the user to
                                // the value of k in the KLRU page replacement
                                // algorithm 
                                //
                                // *******************************************

float LRU_K_CORR_REF_PERIOD = 0.0000001; // correlated reference period used by
                                         // LRU-K buffer replacement algorithm.

short PREFETCH=0;               // Politique de prechargement des objets
                                // 0 = Aucune
                                // 9 = Autre (DSTC)
                                // Prefetch policy to be used
                                // Note: the DSTC (9) prefetch policy has
                                //       not been implemented


// Definition de la base de donnees OCB (Object Clustering Benchmark)
// Parameters for the OCB benchmark

int NC=MNC;                     // Nombre de classes
short MAXNREF=10;               // Nombre max. de references
int BASESIZE=50;                // Taille de base des instances
int NO=MNO;                     // Nombre total d'objets, including deleted
                                // objects 
int ACTUALNO=MNO;               // Actual number of objects
short NREFT=4;                  // Nombre de types de reference
short DIST1=1;                  // Distribution aleatoire des types de reference
short DIST2=1;                  // Distribution aleatoire des references aux classes
short DIST3=1;                  // Distribution aleatoire des objets au sein des classes
short DIST4=1;                  // Distribution aleatoire des references d'objet
                                // 1 = Uniforme
                                // 2 = Normale
                                // 9 = Autre
                                // Types of ditributions that you can specify for the
                                // various object graph structure parameters
                                // only 1 = uniform distribution appears to have
                                // been implemented

int INFCLASS=1;                 // Borne inferieure des classes referencees par DIST2

// Default NC
int SUPCLASS=50;                // Borne superieure des classes referencees par DIST2


float OBJ_THINK= 1;           // Temps de latence moyen entre deux transactions


// Definition des transactions OCB
// See edbt89 paper of his to see what the parameters mean
// default 4000
float TRANS_THINK=4000;               // Temps de latence moyen entre deux transactions



char * trans_name[] = {
  "Set-oriented accesses",
  "Simple traversals",
  "Hierarchy traversals",
  "Stochastic traversals",
  "Random Attribute Update",
  "Object Insertion",
  "Object Deletion",
  "Sequential Attribute Update",
  "Random Reference Insertion",
  "Random Reference Deletion",
  "Sequential oid referencing"
};

// Default 0.25
float PSET=0.0;                // Probabilite d'occurence d'un acces ensembliste

// Default 0.25
float PSIMPLE=1.0;             // Probabilite d'occurence d'un parcours simple

// Default 0.25
float PHIER=0.0;               // Probabilite d'occurence d'un parcours hierarchique

// Default 0.25
float PSTOCH=0.0;              // Probabilite d'occurence d'un parcours stochastique

// default value is 50
int NUPDT = 1;               // Number of updated objects in random updates

float POBJRAU=0.0;           // Probability of running a transaction that
                             // updates the attributes of NUPDT random objects.

float POBJI=0.0;           // Probability of running object insertion 
                           // transaction

float POBJD=0.0;           // Probability of running object deletion
                           // transaction
float POBJSAU = 0.0;       // Probability of running sequential attribute 
                           // update transaction

float PREFI = 0.0;         // Probability of running reference insertion
                           // transaction 

float PREFD  = 0.0;        // Probability of running reference deletion
                           // transaction 

float POID = 0.0;          // Probability of sequential access in terms of oid
                           // that is oid 0 is assessed first then oid 1, 2, 3,
                           // etc....

float PCLUSTD=0.0;         // Probabilite de demande de regroupement externe

int SETDEPTH=3;                 // Profondeur des acces ensemblistes

// Default 3
int SIMDEPTH=2;                 // Pronfondeur des parcours simples

// Default 5
int HIEDEPTH=3;                 // Pronfondeur des parcours hierarchiques
int STODEPTH=3;                // Pronfondeur des parcours stochastiques

int SEQOIDDEPTH = 1000;        // the number of objects accessed by sequential
                               // scan of objects transaction.

// Default 1
short DIST5=9;                  // Distribution aleatoire des objets racine des transactions

short DIST100=9;                // Random distribution for POBJRAU, PREFI and
                                // PREFD
short DIST101=1;                // Random distribution for POBJI
short DIST102=9;                // Random distribution for POBJD
short DIST103=1;                // Random distribution for POBJSAU


// Parametres de DSTC 
// See [Buullat ecoop96] paper explanation of the parameters 
// These default parameters appear to be fairly stat collection expensive,
// that is fine grained stats are processed and stored ( this is mainly due
// to the low values for the threshold values. 

int N=200;                      // Nombre maximum d'entrees dans MO durant
                                // une periode
int NP=1;                       // Nombre de periodes apres lequel un lien
                                // est obsolete
int P=1000;                     // Modulo des periodes

// Default 1.0
float TFA=1.0;                    // Valeur du seuil Tfa

// Default 1.0
float TFE=1.0;                    // Valeur du seuil Tfe

// Default 1.0
float TFC=1.0;                  // Valeur du seuil Tfc

// Default 0.3
float W=0.3;                    // Coefficient de ponderation


//int S=10;                       // Taille de la fenetre de prechargement

//////////////////////////////////////////////////////////////////////////////

// parameters for graph partitioning clustering

int GP_TYPE = 1;              // The type of graph partitioning algorithm to
                              // use:
                              //     0 - partitions placed in size order
                              //     1 - partitions placed in heat order   

int GPNUMACCESS = 200;        // number of objects accessed before a
                              // cluster analysis is triggered 
int GPAGRAIN = 50;            // Number of in memory pages analysed during
                              // each analysis iteration. 
float GP_CB_THRESHOLD = 0.1;  // Clustering badness threshold, used to 
                              // detemine when a page is badly clustered
                              // to be inserted into the clustering priority
                              // queue.
int GPRGRAIN = 25;            // Reclustering grain used to determine the 
                              // number of pages to recluster in each
                              // iteration
int GPCALG = 0;               // select which graph partitioning algorithm
                              // to use.
                              // 0 - greedy graph partitioning,
                              // from: Partition-Based Clustering in Object 
                              // Bases: From Theory to Practice 

int GP_CLEAR_QUEUE_NUM = 10;

///////////////////////////////////////////////////////////////////////////////

// paramters for PRP clustering

int PRPCALG = 0;              // Selects which PRP clustering algroithm to use
                              // 0 - PRP prioritise (See Zhen's paper)
                              // 1 - PRP random (See Zhen's paper)
                              // (implementation for PRP random needs to be
                              //  checked out)    

int PRPAGRAIN = 50;           // Number of in memory pages analysed during
                              // each analysis iteration. 
int PRPPRIORGRAIN = 25;       // Reclustering grain for PRP prioritise, the number of 
                              // pages to recluster in each iteration.
int PRPRANDRGRAIN = 10;       // reclustering grain for PRP random, 
                              // the number of pages to recluster in each 
                              // iteration.

int PRPNUMACCESS = 200;       // number of objects is accessed before a 
                              // iteration PRP is run.


float PRP_CB_THRESHOLD = 0.1; // clustering threshold, quality of clustering
                              // required before the page will be placed on
                              // priority queue for reclustering.

int PRP_CLEAR_QUEUE_NUM = 10;

//////////////////////////////////////////////////////////////////////////////

// DRO Parameters

int DRONUMACCESS      = 200;  // the number of objects accessed before the
                              // current clustering is checked for possible
                              // reorganisation.

float DROMINUR        = 0.001;// minimum usage rate, see DRO paper for details
int   DROMINLT        = 2  ;  // minimum loading threshold
float DROPCRate       = 0.02; // page clustering rate
int   DROMaxD         = 1;    // maximum distance
float DROMaxDR        = 0.2; // maximum dissimilarity rate
float DROMaxRR        = 0.95;  // maximum resemblance rate

// This parameter is disabled since only SUInd = true is implemented, 
// the reason is due to the way phyical reorganisation in this instance
// of DRO has been implementated.
// bool DROSUInd         = true; // statistics update indicator


///////////////////////////////////////////////////////////////////////////////

float HOT_START;           // The start point of the hot region

int WSS_WIN_SIZE  = 6;    // working set size window size, see Tsangaris 91 
                          // paper

int LT_EF_ON_NUM_TRANS = 7000; // used for calculation of long term expansion
                               // factor, the number of transactions processed
                               // before steady state begins 

// Parametres induits

// Probabilites cumulees d'occurence des
float PCT1, PCT2, PCT3, PCC, PORAU, POI, POD, POSAU, PRI, PRD, PID;  
  
                                // transactions et demandes de groupement
float STOCHTAB[MMAXNREF];       // Probabilites parcours stochastique

/////////////////////////////////////////////////////////////////////
// Compteurs statistiques propres a VOODB2
/////////////////////////////////////////////////////////////////////

// Nombre de transactions

int NBTRANS[NTTRANS+1];
float NBTRANSC[NTTRANS+1], NBTRANSC2[NTTRANS+1];

// Temps de reponse

float RTIME[NTTRANS+1], RTIMEC[NTTRANS+1], RTIMEC2[NTTRANS+1];
int NBST[NTTRANS+1]; // # Started transactions

// Nombre d'objets accedes

int NBOBJ[NTTRANS+1];
float NBOBJC[NTTRANS+1], NBOBJC2[NTTRANS+1];

// Nombre de groupements

int NBCL;
float NBCLC, NBCLC2;

// Duree de regroupement

float CTIME, CTIMEC, CTIMEC2;

// Surcharge traitement groupement

float TCTIME, TCTIMEC, TCTIMEC2;

// Nombre d'entrees/sorties (total, transactions, groupement)
// number of I/O generated during total, transaction and clustering
int NBIO, TNBIO, CNBIO, WNBIO, PNBIO;
float NBIOC, NBIOC2, TNBIOC, TNBIOC2, CNBIOC, CNBIOC2, 
  WNBIOC, WNBIOC2, PNBIOC, PNBIOC2;

// Nombre de pages disque

float NBPGC, NBPGC2;

// Nombre et taille moyenne des clusters

int NCLUSTERS, TCLUSTERS;
float NCC, NCC2, TCC, TCC2;


//////////////////////////////////////////////////////////////////////////////
// D-OCB Parameters
// ----------------
//
//////////////////////////////////////////////////////////////////////////////

int   MOVE_WINDTYPE      = 1;    // MoveWindType:
                                 //               0 No moving or dependency
                                 //               1 Moving Window
                                 //               2 Gradual Moving Window
                                 //               3 No moving, only dependency
                                 //               4 Heat Growth Change
                                 //               5 Cycle of Change

float DEP_RANDHOTREGSIZE = 0.02; // The size of the hot region when random
                                 // dependency is used
float DEP_RANDHOTREGPROB = 0.99; // The probability of referencing the hot
                                 // region when random dependency is used

float DEP_C              = 1.0;  // size of candidate set for travered objects
                                 // dependency expressed as a percentage of
                                 // traversed objects

float DEP_U              = 1.0;  // size of candidate set for same class
                                 // dependency expressed as a fraction of total
                                 // size of the class


int   DEP_NUMDREF        = 20  ;  // the number of D-references per object


float MOVE_REGIONSIZE    = 0.005; // The size of each HRegion for moving window
                                  // and gradual moving window.  Size is
                                  // specified as a fraction of total size.


float MOVE_HIGHESTPROBW  = 0.98; // the highest probability weight of regions
                                 // in the moving window of change
float MOVE_LOWESTPROBW   = 0.0001; // the lowest probability weight of regions
                                 // in the moving window of change
int   MOVE_H             = 1000; // The number of roots selected before the
                                 // access pattern moves one increment
                                 // ***** NOTE **********
                                 // This definition of H is fact the inverse
                                 // of what in defined in the DOCB paper.

int   MOVE_ASSIGNMETHOD  = 2   ; // The object assignment method:
                                 //   1 - by class assignment
                                 //   2 - random assignment

float MOVE_PROBWINCRSIZE = 0.02 ;// The amount by which the probability weight
                                 // of each region changes for gradual moving
                                 // window.


int   DEP_R             = -1   ;// The maximum number of consecutive dependency
                                // traversals which are not of the type
                                // RANDOM.
                                // A value of "-1" will turn off option;

float MOVE_SMALLREGIONSIZE = 0.01; // Used by growing heat, size of small 
                                   // region.  Specified in fraction of entire
                                   // database.
float MOVE_LARGEREGIONSIZE = 0.02; // Used by growing heat, size of large
                                   // region.  Also specified in fraction of
                                   // entire database.
int   MOVE_NUMPERIODS    = 3 ;    // Number of periods, for growing heat

float DEP_RANDOMPROB     = 1.0;  // probability of using random dependency
float DEP_SREFPROB       = 0.0;  // probability of using s-ref dependency 
float DEP_DREFPROB       = 0.0;  // probability of using d-ref dependency
float DEP_TRAVERSEDPROB  = 0.0;  // probability of using traversed dependency
float DEP_CLASSPROB      = 0.0;  // probability of using same class dependency


                             
/////////////////////////////////////////////////////////////////////////////

/***************************************************************************/


/////////////////////////////////////////////////////////////////////
// Fonction de tirage aleatoire de nombre entier customisee
/////////////////////////////////////////////////////////////////////
// Retourne un entier entre min et max selon la distribution dist
/////////////////////////////////////////////////////////////////////

int CRand(short dist, int min, int max) {

  int res;

  switch(dist) {

    // Distribution uniforme
    case 1: res=IUni(min,max);break;

    // Distribution normale
    case 2: res=-1;break; // A FAIRE !!   

    // HotCold distribution 
    case 9: res= IHotCold(min, max, HOT_START, HOTRANGE, HOTACCESSPROB);break;    
    // Erreur
    default: res=-1;printf("\nError: Unknown random distribution!\n");

  }

  return res;
}

/////////////////////////////////////////////////////////////////////
// Fonction t-distribution
/////////////////////////////////////////////////////////////////////
// Retourne la bonne valeur critique pour la t-distribution de 
// Student en fonction de n
/////////////////////////////////////////////////////////////////////

/*
float t(int n) {

  if (n<=0) return -1; // Erreur
  else if (n<=100) return TDIST[n-1]; // 1..100
  else if (n<=150) return TDIST[((n-100)/2)+99]; // 102..150
  else if (n<=1000) return TDIST[((n-100)/100)+124]; // 200..1000
  else return TDIST[134]; // infini
}*/
