
/////////////////////////////////////////////////////////////////////
// VOODB2 (Virtual Object Oriented Database)
// Modele d'evaluation de performances generique pour SGBDOO
// Version 2.0 C++, aout 1998
// Jerome Darmont
// LIMOS, Universite Blaise Pascal (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// voodb2uc.h : Definition des classes utilitaires
/////////////////////////////////////////////////////////////////////

class ChList;
class IntCell;

/////////////////////////////////////////////////////////////////////
// CLASSE ChList
/////////////////////////////////////////////////////////////////////
// Liste chainee d'entiers
/////////////////////////////////////////////////////////////////////

class ChList {

  public:                       // Methodes

    ChList();                   // Constructeur
    ~ChList();                  // Destructeur
    void Insert(int place, int value); // Insertion en place
    void Delete(int place);     // Suppression en place
    void Update(int place, int value); // Modification en place
    void Reverse();             // Inversion de liste chainee
    int Scan(int place);        // Retour valeur place
    int NbElem();               // Retour nombre d'elements
    void Display();             // Affichage liste
    void Print();               // Affichage pointeurs
    static void * operator new(size_t size);
    static void operator delete(void * deadObject, size_t size);

  private:                      // Attributs

    int nbelem;                 // Nombre d'elements
    IntCell *head;              // Ptr. vers la tete de liste
    IntCell *queue;             // Ptr. vers la fin de la liste

    int position;               // Position courante dans la liste
    IntCell *cur;               // Pointeur cellule courante
    IntCell *prev;              // Pointeur cellule precedente
    IntCell *next;              // Pointeur cellule suivante

    // Methode privee : positionnement dans une liste a une place
    //                  avec mise a jour des attributs position,
    //                  cur, prev et next

    void Pos(int place);

};

/////////////////////////////////////////////////////////////////////
// CLASSE IntCell
/////////////////////////////////////////////////////////////////////
// Cellule de liste chainee d'entiers
/////////////////////////////////////////////////////////////////////

class IntCell {

  public:                       // Methodes

    IntCell(int val);           // Constructeur
    void SetVal(int val);       // Initialisation value
    void SetNext(IntCell *n);   // Initialisation ptr Next
    void SetPrev(IntCell *n);   // Initialisation ptr Prev
    int Value();                // Retourne la valeur
    IntCell *Next();            // Retourne la cellule suivante
    IntCell *Prev();            // Retourne la cellule precedente

  private:                      // Attributs

    int value;                  // Valeur entiere
    IntCell *next;              // Cellule suivante (ptr)
    IntCell *prev;              // Cellule suivante (ptr)

};

